var dropdown_event = 0;
var columns = 3;
var closeTimeout	= 500;
var openTimeout	= 0;
var hover = 1;

var closetimer	= 0;
var opentimer	= 0;
var ddmenuitem	= 0;

var closehovtimer = 0;
var openhovtimer = 0;
var hovicon = 0;
var hovered = 0;

var dropdown_enabled = 1;

var expand = "+";
var collapse = "-";




function override_html(theme) {
  
  if (getIEVersionNumber() < 8) {
    browser_warning();
  }
}



function set_menu_globals(event_in, expand_in, collapse_in, closeTimeout_in, openTimeout_in, columns_in, hover_in) {
  dropdown_event = event_in;
  expand=expand_in;
  collapse=collapse_in;
  closeTimeout = closeTimeout_in;
  openTimeout = openTimeout_in;
  columns = columns_in;
  hover = hover_in;
}


function getElementsByClass(tag, cl) {
     var elem = document.getElementsByTagName(tag);
     var arr = new Array();
     for(i = 0,iarr = 0; i < elem.length; i++) {
          att = elem[i].className;
          if(att == cl) {
               arr[iarr] = elem[i];
               iarr++;
          }
     }
     return arr;
} 

//http://www.java2s.com/Code/JavaScript/Development/GetIEVersionNumber.htm
function getIEVersionNumber() {
    var ua = navigator.userAgent;
    var MSIEOffset = ua.indexOf("MSIE ");
    
    if (MSIEOffset == -1) {
        return 100;
    } else {
        return parseFloat(ua.substring(MSIEOffset + 5, ua.indexOf(";", MSIEOffset)));
    }
}

function browser_warning() {
  if ((get_cookie("browser_warning") != "yes") && (getIEVersionNumber() <= 6)) {
    alert("ShopSite does not support Internet Explorer version 6 or lower. While all the functionality is still available, for better user interface experience we recommend updating your browser.");
    set_cookie("browser_warning", "yes", 120);
  }
}

function memorize_menu_configuration() {
  var cookie = "";
  var menus = getElementsByClass("ul","l2_list");
  var i=0;
  for(; i<menus.length; i++)
  {
    if (menus[i].style.display == 'block')
      cookie = cookie + "1";
    else
      cookie = cookie + "0";
  }
  
  for (; i < 100; i++) {
    cookie = cookie + "0";
  }
  
  set_cookie("menu_configuration", cookie, 120);
}

function recall_menu_configuration() {
  var cookie = get_cookie("menu_configuration");
  if (cookie != null) {
      var menus = getElementsByClass("ul","l2_list");
      var clickers = getElementsByClass("a","cl");
      
      var ce = 0;
      
      for (c = 0; c < cookie.length; c++) {
        if (menus[c]) {
          if (cookie.charAt(c) == 0) {
            menus[c].style.display='none';
            clickers[c].innerHTML = expand;
          } else {
            menus[c].style.display='block';
            clickers[c].innerHTML = collapse;
            ce++;
          }
        }
      }
  }
}

function show_tip(id) {
  var tip;
  tip = document.getElementById("nav_tip_"+id);
  tip.style.visibility = 'visible';
}

function hide_tip(id) {
  var tip;
  tip = document.getElementById("nav_tip_"+id);
  tip.style.visibility = 'hidden';
}

function hide_tips() {
  var tip;
  for (i = 1; i <= 11; i++) {
    tip = document.getElementById("nav_tip_m"+i);
    tip.style.visibility = 'hidden';
  }
}

//Peter-Paul Koch & Alex Tingle http://blog.firetree.net/2005/07/04/javascript-find-position/
function findPosX(obj)
{
  var curleft = 0;
  if(obj.offsetParent)
      while(1) 
      {
        curleft += obj.offsetLeft;
        if(!obj.offsetParent)
          break;
        obj = obj.offsetParent;
      }
  else if(obj.x)
      curleft += obj.x;
  return curleft;
}

function preload_images(path) {
  var i = 0;
  var icons = ['pages', 'products', 'images', 'merchandising', 'orders', 'reports', 'commercesetup', 'utilities', 'preferences', 'mystore', 'help'];
  image = new Image();
  for (i = 0; i < 11; i++) {    
    image.src=path + icons[i] + "-regular.gif";
  }
  
  if (hover) {
    for (i = 0; i < 11; i++) {    
      image.src=path + icons[i] + "-hover.gif";
    }
  }
  

}

function adjust_one_drop (i, firstOffset) {
      
      var icon = document.getElementById("nav_img_m" + i);
      if (icon.complete) {
        var holder = document.getElementById("mh" + i);
        var hl = document.getElementById("hl"+i);
        iconX = findPosX(icon);
        if (i == 1 || i == 11)
          hl.style.width = (icon.offsetWidth - 3) + "px";
        else
          hl.style.width = icon.offsetWidth + "px";
          
        if (i == 1)  
          hl.style.marginLeft=(iconX - firstOffset/*icon.offsetLeft -firstOffset*/ + 3) + "px";
        else
          hl.style.marginLeft=iconX - firstOffset/*icon.offsetLeft -firstOffset*/ + "px";

        /*IE does not like holder.style.left. I do not like IE.*/
        holder.style.marginLeft=(iconX -holder.offsetWidth/2 + icon.offsetWidth/2 - firstOffset) + "px";
        //alert(i + "+");
        return 1;
      } else {
        window.setTimeout("adjust_locations();", 300);
        //window.setTimeout("adjust_one_drop(" + i + "," + firstOffset + ");", 500);
        //alert(i + "-");
        return 0;
      }
}

function adjust_one_tip(i, firstTipOffset) {
  var icon = document.getElementById("nav_img_m" + i);
  if (icon.complete) {
    var tip = document.getElementById("nav_tip_m"+i);    
    iconX = findPosX(icon);
    tip.style.left = iconX - tip.offsetWidth/2 + icon.offsetWidth/2  - firstTipOffset + "px";
    //tip.style.marginLeft = (iconX - tip.offsetWidth/2 + icon.offsetWidth/2  - firstTipOffset) + "px";
    return 1;
  } else {
    window.setTimeout("adjust_locations();", 300);
    //window.setTimeout("adjust_one_tip(" + i + "," + firstTipOffset + ");", 300);
    return 0;
  }
}


function adjust_locations() {
  var holder;
  var hl;
  var icon;
  var iconX;  
  holder = document.getElementById("mh1");
  var iconLast = document.getElementById("nav_img_m11");
  if (iconLast.complete) {
    if (holder) 
    {
      var firstOffset = document.getElementById("nav_menu").offsetLeft;
      for (i = 1; i <= 11; i++) {
        adjust_one_drop (i,firstOffset);
      }
    }
    else if (document.getElementById("nav_tip_m1").offsetParent != null) {
      
      //var firstTipOffset  = document.getElementById("nav_tip_m1").offsetParent.offsetLeft;
      var firstTipOffset = document.getElementById("nav_menu").offsetLeft;
      for (i = 1; i <= 11; i++) {
        adjust_one_tip (i,firstTipOffset);
      }
      dropdown_enabled = 0;
      closeTimeout = 0;
      openTimeout = 0;
    }
  } else {
    window.setTimeout("adjust_locations();", 300);
  }
}

function twiddle(id, clicker_id)
{
  var listitem = document.getElementById(id);
  var clicker = document.getElementById(clicker_id);
  
  if (listitem.style.display == 'block') {
  
    listitem.style.display = 'none';
    clicker.innerHTML = expand;
  } else {
  
    listitem.style.display = 'block';
    clicker.innerHTML = collapse;
  }
}

// open hidden layer
function mopen(id)
{	
	// cancel close timer
  
  
	mcancelclosetime();
  mcancelopentime();
  
  opentimer = window.setTimeout("mopen_inn('"+id+"')",openTimeout);
    
}

function mopen_inn(id) {
  
  if(ddmenuitem)  {
    ddmenuitem.style.visibility = 'hidden';
  }
    
  
  if ((dropdown_event == 0) || ((dropdown_event == 1) && ddmenuitem != document.getElementById(id))) 
  {
    ddmenuitem = document.getElementById(id);
    ddmenuitem.style.visibility = 'visible';
  } else if (dropdown_event == 1) {
    ddmenuitem = "";
  }
}



function mhover(id) 
{
  if (hover) {
  	mcancelhovclosetime();
    mcancelhovopentime();  
    openhovtimer = window.setTimeout("mhover_inn('"+id+"')",openTimeout);
  }
}

/*function mhover_inn(id) {

  var id_app = "nav_img_"+id;

  if(hovicon && (hovered == 1))  {
    
    hovicon.src = hovicon.src.replace(/-hover.gif/, "-regular.gif");
    hovered = 0;
  }
    
  
  if (hovicon != document.getElementById(id_app)) 
  {
    hovicon = document.getElementById(id_app);
    if (hovicon.src.search(/-regular.gif/) != -1) {
      hovered = 1;
      hovicon.src = hovicon.src.replace(/-regular.gif/, "-hover.gif");
    }
    
    //alert(hovicon.src);
  } else {
    hovicon = 0;
  }
}*/

function mhover_inn(id) {

  var id_app = "nav_img_"+id;

  if (hovicon != document.getElementById(id_app))
  {
    if(hovicon && (hovered == 1)) {
      hovicon.src = hovicon.src.replace(/-hover.gif/, "-regular.gif");
      hovered = 0;
    }
    
    hovicon = document.getElementById(id_app);
    if (hovicon.src.search(/-regular.gif/) != -1) {
      hovered = 1;
      hovicon.src = hovicon.src.replace(/-regular.gif/, "-hover.gif");
    }
  }
} 



// close showed layer
function mclose()
{
	if(ddmenuitem) {
    ddmenuitem.style.visibility = 'hidden';
  }
  if(hovicon && (hovered == 1)) {
    hovicon.src = hovicon.src.replace(/-hover.gif/, "-regular.gif");
    hovered = 0;
  }
  hovicon = 0;
}

function mcloseout(event) {
  if (!event)
    event = window.event;
  var target = event.target;
  if (!target)
    target = event.srcElement;
    
  if (!target) {
    mclose();  
    ddmenuitem = "";
  } else {
    if (target.src)
      var str = new String(target.src);
    else
      var str = new String(target);
  }
  
  
  
  
  if (!str || (str.search("http://") == -1 && str.search("https://") == -1)) {
    mclose();  
    ddmenuitem = "";
  }
  
}

// go close timer
function mclosetime()
{
	closetimer = window.setTimeout(mclose, closeTimeout);
  if (hover)
    closehovtimer = window.setTimeout(mhovclose, closeTimeout);
}



function munhover()
{
  if (hover && !dropdown_enabled)
    closehovtimer = window.setTimeout(mhovclose, closeTimeout);
}

function mhovclose()
{
	if(hovicon) {
    hovicon.src = hovicon.src.replace(/-hover.gif/, "-regular.gif");
  }
  hovicon = 0;
}





// cancel close timer
function mcancelclosetime()
{
  mcancelhovclosetime();
  mcancelopentime();
	if(closetimer)
	{
		window.clearTimeout(closetimer);
		closetimer = null;
	}
}

// cancel open timer
function mcancelopentime()
{
	if(opentimer)
	{
		window.clearTimeout(opentimer);
		opentimer = null;
	}
}

function mcancelhovclosetime() {
  mcancelhovopentime();
	if(closehovtimer)
	{
		window.clearTimeout(closehovtimer);
		closehovtimer = null;
	}
}

function mcancelhovopentime()
{
	if(openhovtimer)
	{
		window.clearTimeout(openhovtimer);
		openhovtimer = null;
	}
}

// close layer when click-out
document.onclick = mcloseout;
