
$(window).load(function() {
  $docheight = $(document).height();
  $docwidth = $(document).width();
   
  var textarea_text = "";
  var id = -1;
  //masking solution courtesy of http://stackoverflow.com/questions/509118/trouble-using-jquery-ui-resizable-and-ui-draggable-with-an-iframe/667342#667342
  $('.OA_iframe').resizable({ //mark it as resizable
    containment: ".content_wide",
    start: function(event, ui) {
        id = $(this).attr('id').substr(10);
        textarea_text = $('#OA_iframe_text_' + id).html();
        
        $("body").append("<div id=\"iframe_mask\" style=\"position: absolute; z-index: 20; left: 0pt; top: 0pt; "
        +" width: " + $docwidth + "px; height: " + $docheight +"px;\"></div>");
        
    },
    stop: function(event, ui) {
      $("#iframe_mask").remove();
      var query = "ajax=save&height="+ui.size.height + "&width="+ui.size.width;
      $.get("easyembed.cgi",query, function(data) {});

    },
    resize: function(event, ui) {
      $('#OA_iframe_text_' + id).html(textarea_text.replace(/height=[0-9]*/gi, "height="+ui.size.height).replace(/width=[0-9]*/gi, "width="+ui.size.width));
    }
  });
  
  $('.OA_iframe_template > select').change(function() {
    id = $(this).parent().attr('id').substr(19);
    textarea_text = $('#OA_iframe_text_' + id).html();
    var rep_str = (jQuery.trim($(this).find('option:selected').text()));
    $('#OA_iframe_text_' + id).html(textarea_text.replace(/template=(.*?)"/gi, "template="+ rep_str+ "\""));
    
    var src = $('#OA_iframe_' + id + " > iframe").attr('src');
    $('#OA_iframe_' + id + " > iframe").attr('src', src.replace(/template=(.*)/gi, "template="+ rep_str));
    
    
    var query = "ajax=save&template="+rep_str;
    $.get("easyembed.cgi", query , function(data) {alert(data);});
    
  });
  
  $('textarea').click(function() {this.select();});

});
