
var CBP_text_idx = 0;

var grid_size = 10;

function startDraggable (initial, paypal_condition, google_condition) {

  
  
  $(window).load(function() {
    if (initial) {

      if ($('#CBP_paypal').length) {
        $('#CBP_paypal_left').val($('#CBP_paypal').offset().left - $('#CBP_container').offset().left);
        $('#CBP_paypal_top').val($('#CBP_paypal').offset().top - $('#CBP_container').offset().top);
      }
      
      if ($('#CBP_google').length) {
        $('#CBP_google_left').val($('#CBP_google').offset().left - $('#CBP_container').offset().left);
        $('#CBP_google_top').val($('#CBP_google').offset().top - $('#CBP_container').offset().top);
      }
      
      if ($('#CBP_amazon').length) {
        $('#CBP_amazon_left').val($('#CBP_amazon').offset().left - $('#CBP_container').offset().left);
        $('#CBP_amazon_top').val($('#CBP_amazon').offset().top - $('#CBP_container').offset().top);
      }
      
      if ($('#CBP_checkout').length) {
        $('#CBP_checkout_left').val($('#CBP_checkout').offset().left - $('#CBP_container').offset().left);
        $('#CBP_checkout_top').val($('#CBP_checkout').offset().top - $('#CBP_container').offset().top);
      }
      
      if ($('#CBP_text_0').length) {
        $('#CBP_text_0_left').val($('#CBP_text_0').offset().left - $('#CBP_container').offset().left-8);
        $('#CBP_text_0_top').val($('#CBP_text_0').offset().top - $('#CBP_container').offset().top-8);
      }
      
      if ($('#CBP_text_1').length) {
        $('#CBP_text_1_left').val($('#CBP_text_1').offset().left - $('#CBP_container').offset().left-8);
        $('#CBP_text_1_top').val($('#CBP_text_1').offset().top - $('#CBP_container').offset().top-8);
      }
      
      calculate_dimensions();
      
      $('#CBP_wrapper').wrap('<form id=\"ser_form\"/>');
      //force switch to new CBP
      jQuery.ajax({
         url:    'payconfig.cgi?ajax=init_cbp&' + $('#ser_form').serialize(),
         success: function(result) {
                    if(result.isOk == false)
                      alert(result.message);
                    else {
                      $('#CBP_wrapper').html(result);
                      $('#CBP_wrapper').unwrap();
                    }
                  },
         async:   false
      });  
    }
    
    
    
    $('.CBP_button').draggable({ 
      containment: '#CBP_container', 
      scroll:false,
      stop: function(event, ui) {
        $('#' + $(this).attr('id') + '_left').val(ui.position.left);
        $('#' + $(this).attr('id') + '_top').val(ui.position.top);
      }
    });
    
    if ($('#CBP_snap_buttons:checked').length) {
      snap_to_grid('.CBP_button');
    }
    
    
    
    if (google_condition == 1) {
      $('#use15').change(function() {
        if ($('#use15:checked').length > 0)
          $('#CBP_google').removeClass('CBP_hide');
        else
          $('#CBP_google').addClass('CBP_hide');
        hide_show_all();
      });
    }
    
    $('#use24').change(function() {
        if ($('#use24:checked').length > 0)
          $('#CBP_amazon').removeClass('CBP_hide');
        else
          $('#CBP_amazon').addClass('CBP_hide');
        hide_show_all();
    });
    
    
      $('#use14').change(function() {
        if (paypal_condition == 1) {
          if ($('#use14:checked').length > 0)
            $('#CBP_paypal').removeClass('CBP_hide');
          else
            $('#CBP_paypal').addClass('CBP_hide');
        }
        hide_show_ss_checkout(paypal_condition);
        hide_show_all();
      });
    
    
    $('#use7').click(function() {$('#CBP_paypal').addClass('CBP_hide'); });
    
    
    
    $('.payment_shopsite').live( 'change', function() {
      hide_show_ss_checkout(paypal_condition);
      hide_show_all();
    });
    
    hide_show_all();  
    
    
    
    $('#button_save_changes').click(function () {
      calculate_dimensions();
      if ((!$('#CBP_paypal').hasClass('CBP_hide') && findIntersectors('#CBP_paypal', '.CBP_button:not(.CBP_hide)'))
        || (!$('#CBP_google').hasClass('CBP_hide') && findIntersectors('#CBP_google', '.CBP_button:not(.CBP_hide)'))
        || (!$('#CBP_amazon').hasClass('CBP_hide') && findIntersectors('#CBP_amazon', '.CBP_button:not(.CBP_hide)'))
        || (!$('#CBP_checkout').hasClass('CBP_hide') && findIntersectors('#CBP_checkout', '.CBP_button:not(.CBP_hide)')))
        return confirm('Your checkout buttons overlap. Are you sure that is how you want them?');
      else return 1;
    });
    
    CBP_text_idx = $('#CBP_text_idx').val();
    $('.CBP_text').draggable({ 
        containment: '#CBP_container', 
        scroll:false,
        stop: function(event, ui) {
          $('#' + $(this).attr('id') + '_left').val(ui.position.left);
          $('#' + $(this).attr('id') + '_top').val(ui.position.top);
        }
    });
    
    if ($('#CBP_snap_text:checked').length) {
      snap_to_grid('.CBP_text');
    }
      
      //auto-resize input text field. http://stackoverflow.com/questions/1288297/jquery-auto-size-text-input-not-textarea/1288372#1288372
      $('.CBP_text > input').keyup(function () {
        var oneLetterWidth = 8;
        var len = $(this).val().length;
        $(this).width(len * oneLetterWidth);
      });
      
      $('.CBP_text > a').click(function () {
        $(this).parent().remove();
        var idx = $(this).attr('id').substr(16);
        var text_indexes = $('#CBP_text_indexes').val();
        $('#CBP_text_indexes').val(text_indexes.replace("|" + idx + "|", "|"));
      });
    
    $('#CBP_add_text').click(function () {
      var html = "<div class='CBP_text CBP_text_added' id=CBP_text_"+CBP_text_idx+">"+
      "<input type=text size=3 name=CBP_text_input_"+CBP_text_idx+" id=CBP_text_input_"+CBP_text_idx+" value='or'>"+
      "<a class='CBP_remove_text' id=CBP_remove_text_"+CBP_text_idx+">x</a>"+
      "<input type=hidden name=CBP_text_"+CBP_text_idx+"_left id=CBP_text_"+CBP_text_idx+"_left value=0>"+
      "<input type=hidden name=CBP_text_"+CBP_text_idx+"_top id=CBP_text_"+CBP_text_idx+"_top value=0>"+
      "</div>";
      
      $('#CBP_container').append($(html));
	  
      setTimeout("$('.CBP_text_added').removeClass('CBP_text_added')", 1000);
      

      $('#CBP_text_'+CBP_text_idx).draggable({ 
        containment: '#CBP_container', 
        scroll:false,
        stop: function(event, ui) {
          $('#' + $(this).attr('id') + '_left').val(ui.position.left);
          $('#' + $(this).attr('id') + '_top').val(ui.position.top);
        }
      });
      
      if ($('#CBP_snap_text:checked').length) {
        snap_to_grid('#CBP_text_'+CBP_text_idx);
      }
      
      //auto-resize input text field. http://stackoverflow.com/questions/1288297/jquery-auto-size-text-input-not-textarea/1288372#1288372
      $('#CBP_text_input_'+CBP_text_idx).keyup(function () {
        var len = $(this).val().length;
        //$(this).width(len * oneLetterWidth);
        $(this).attr('size', len);
      });
      
      $('#CBP_remove_text_'+CBP_text_idx).click(function () {
        $(this).parent().remove();
        var idx = $(this).attr('id').substr(16);
        var text_indexes = $('#CBP_text_indexes').val();
        $('#CBP_text_indexes').val(text_indexes.replace("|" + idx + "|", "|"));
      });
      
      var text_indexes = $('#CBP_text_indexes').val();
      $('#CBP_text_indexes').val(text_indexes + CBP_text_idx + "|");
    
      CBP_text_idx++;
      
    });
    
    
    
    $('#CBP_snap_buttons').change(function() {
      if ($('#CBP_snap_buttons:checked').length) {
        snap_to_grid('.CBP_button');
      } else {
        $('.CBP_button').draggable( "option" , "grid" , [ 1,1 ] );
      }
      
    });
    
    $('#CBP_snap_text').change(function() {
      if ($('#CBP_snap_text:checked').length) 
        snap_to_grid('.CBP_text');
      else
        $('.CBP_text').draggable( "option" , "grid" , [ 1,1 ] );
    });
    
    
  });
  
  
  
}

function snap_to_grid(selector) {
  $(selector).draggable( "option" , "grid" , [ grid_size,grid_size ] );
  $(selector).each(function(index) {
    var left = Math.floor(parseInt($(this).css('left')) / grid_size) * grid_size;
    var top = Math.floor(parseInt($(this).css('top')) / grid_size) * grid_size;
    if (!isNaN(left)) {
      $(this).css('left', left);
      $('#' + $(this).attr('id') + '_left').val(left);
    }
    if (!isNaN(top)){
      $(this).css('top', top);
      $('#' + $(this).attr('id') + '_top').val(top);
    }
  });
}

function calculate_dimensions() {

  var CBP_width = 0;
  var CBP_height = 0;
  $('.CBP_button, .CBP_text').each(function(index) {
    if (!$(this).hasClass('CBP_hide')) {
      var right = $(this).offset().left + $(this).width();
      if (right > CBP_width)
        CBP_width = right;
        
      var bottom = $(this).offset().top + $(this).height();
      if (bottom > CBP_height)
        CBP_height = bottom;
    }
  });
  
  $('#CBP_width').val(CBP_width - $('#CBP_container').offset().left);
  $('#CBP_height').val(CBP_height - $('#CBP_container').offset().top);
}


function hide_show_ss_checkout(paypal_condition) {
  if ($('.payment_shopsite:checked').length > 0 || (paypal_condition == 0 && $('#use14:checked').length > 0)) {
    $('#CBP_checkout').removeClass('CBP_hide');
  } else {
    $('#CBP_checkout').addClass('CBP_hide');
  }
}

function hide_show_all() {
  if ($('.CBP_hide').length > 2) {
    $('#CBP_wrapper').css({display:'none'});
    $('#CBP_options').css({display:'none'});
    $('#CBP_few').css({display:'block'});
  }
  else {
    $('#CBP_wrapper').css({display:'block'});
    $('#CBP_options').css({display:'block'});
    $('#CBP_few').css({display:'none'});
  }
}

//http://stackoverflow.com/questions/1560926/efficiently-detect-when-sibling-elements-overlap
function findIntersectors(targetSelector, intersectorsSelector) {
  

  var res = false;
    var $target = $(targetSelector);
    var tAxis = $target.offset();
    var t_x = [tAxis.left, tAxis.left + $target.outerWidth()];
    var t_y = [tAxis.top, tAxis.top + $target.outerHeight()];

    $(intersectorsSelector).each(function() {
      if (!res) {
        var $this = $(this);
        if ($this.attr('id') != $target.attr('id')) {
          
            var thisPos = $this.offset();
            var i_x = [thisPos.left, thisPos.left + $this.outerWidth()]
            var i_y = [thisPos.top, thisPos.top + $this.outerHeight()];
            

            if ( t_x[0] < i_x[1] && t_x[1] > i_x[0] &&
                 t_y[0] < i_y[1] && t_y[1] > i_y[0]) {
                //intersectors.push($this);
                res = true;
            }
        }
      }
    });
    //return intersectors;
    return res;
}

