var state = {
  selected_layout: "",
  selected_theme: "",
  selected_screen: "page_screen",
  selected_file: "",
  preloaded: false,
  initiated: false,
  
  ADC_button_url: "",
  VC_button_url: "",
  ADC_button_type: "",
  VC_button_type: ""
};


function preload_theme_images(layout, prev, obj) {
  if (!state.preloaded && (layout == state.selected_layout)) {
      if (prev.complete) {
        
        var url1 = $(obj).find('.theme_product_url').val();
        var i = new Image();
        get_image_src(url1, i, 0);
        
        
        var url2 = $(obj).find('.theme_cart_url').val();
        var i = new Image();
        get_image_src(url2,i, 0);
       
        
        var next = $(obj).next();
        
        if (next.length) {
          preload_theme_images(layout, i,next);
        } else
          state.preloaded = true;
        
        
      }
       else
        setTimeout(function(){preload_theme_images(layout, prev,obj)}, 50);
  }
}

$(window).load(function() {
  

  $('#layout_list > li').click(function() {
    state.preloaded = false;
    $('.selected_layout').removeClass('selected_layout');
    state.selected_layout = $(this).find('.layout_name_input').val();
    state.selected_file = $(this).find('.layout_name').attr('id');
    $(this).addClass('selected_layout');
    
    $('#theme_list_wrapper').find('.selected_theme_list')
      .replaceWith($(this).find('.theme_list').clone(false).removeClass('theme_list').addClass('selected_theme_list'));    
    
    $('.theme_preload_img').remove();
    
    
    //$('.selected_theme_list > li:first').click();
    if (state.initiated || (state.selected_theme.length == 0))
      $('.selected_theme_list > li:first').click();
    else
      $('.selected_theme_list > li > .theme_name_input[value="'+state.selected_theme+'"]:first').parent().click();
    
    
  });
  
  
  
  
  
  $('.selected_theme_list > li').live('click', function() {
    state.initiated = true;
    $('#selected_theme').removeAttr('id');
    state.selected_theme = $(this).find('.theme_name_input').val();
    $(this).attr('id','selected_theme');
    
    $('.' + state.selected_screen).click();
  });
  
  
  
  
  
  $('.cart_screen, .page_screen').click(function() {
    var url = "";
    var jpg;
    
    $('#selected_screen').removeAttr('id');
    state.selected_screen = $(this).attr('class');
    
    
    var which = '.theme_product_url';
    if (state.selected_screen == 'cart_screen')
      which = '.theme_cart_url';
    
    url = $('#selected_theme').find(which).val();
    
    $(this).attr('id','selected_screen');
    //jpg = url.replace(/\.html?/i,".jpg");
    
    var image = new Image();
    get_image_src(url, image, 1);
    //image.src = jpg;
    preload_theme_images(state.selected_layout, image, $('.selected_theme_list').find('li:first'));
    

    $('#themeFile').val(state.selected_file);
    $('#themeName').val(state.selected_theme);
    
  });
  
  if (state.selected_layout.length) {
    var t = $('#layout_list > li > .layout_name_input[value="'+state.selected_layout+'"]').closest('li');
    $('#layout_list').scrollTop(t.offset().top - $('#layout_list').offset().top);
  }
  else
    var t = $('#layout_list > li:first');
  t.click();
  
  
  
  
  
  
  $('#upload_buttons, #text_buttons, #button_list > li').click(function() {
    $('.selected_buttons').removeClass('selected_buttons');
    $(this).addClass('selected_buttons');
  });
  
  
  $('#ADC_button_upload, #VC_button_upload').change(function() {
    var file = $(this).val();
    if (file.length) {
      if (file.search(/\.jpg|.png|.gif/i) != file.length-4)
        alert("Button extension has to be .jpg, .png, or .gif");
      else {
        if ($(this).attr('id') == 'ADC_button_upload')
          var target = '#ADC_button';
        else
          var target = '#VC_button';
        var options = {
          target: target,
          success: function(responseText, statusText, xhr, $form) { 
            if (target == '#ADC_button')
              state.ADC_button_url = $(responseText).attr('src');
            else
              state.VC_button_url = $(responseText).attr('src');
          },
          async: false,
          forceSync: true
        }
        
        $(this).wrap('<form enctype="multipart/form-data" action="themes.cgi?ajax=upload_button" method=post></form>');
        $(this).parent().ajaxSubmit(options);
        $(this).unwrap();
      }
    }
  });
  
  
  $('#button_list > li').click(function() {
    state.ADC_button_type = "shopsite";
    state.VC_button_type = "shopsite";
    $('#ADC_button').html('<img src="'+ $(this).find(':eq(0)').attr('src') + '" class=cart_button >');
    $('#VC_button').html('<img src="'+ $(this).find(':eq(1)').attr('src') + '" class=cart_button >');
  });
  
  
  $('#ADC_button_upload').click(function() {
    state.ADC_button_type = "upload";
    if (state.ADC_button_url.length)
      $('#ADC_button').html('<img src="'+ state.ADC_button_url + '" class=cart_button >');
  });
  
  $('#VC_button_upload').click(function() {
    state.VC_button_type = "upload";
    if (state.VC_button_url.length)
      $('#VC_button').html('<img src="'+ state.VC_button_url + '" class=cart_button >');
  });
  
  $('#ADC_button_text').click(function() {
    state.ADC_button_type = "text";
    $('#ADC_button').html("<input type=button value=\"" + $(this).val() + "\">");
  });
  
  $('#VC_button_text').click(function() {
    state.VC_button_type = "text";
    $('#VC_button').html("<input type=button value=\"" + $(this).val() + "\">");
  });
  
  $('#ADC_button_text').keyup(function() {
    $('#ADC_button').html("<input type=button value=\"" + $(this).val() + "\">");
  });
  
  $('#VC_button_text').keyup(function() {
    $('#VC_button').html("<input type=button value=\"" + $(this).val() + "\">");
  });

  
  $('#button_next').click(function() {
    $('#ADC_button_type').val(state.ADC_button_type);
    if (state.ADC_button_type == "text")
      $('#ADC_button_inp').val($('#ADC_button > input').val());
    else
      $('#ADC_button_inp').val($('#ADC_button > img').attr('src'));
    
    $('#VC_button_type').val(state.VC_button_type);  
    if (state.VC_button_type == "text")
      $('#VC_button_inp').val($('#VC_button > input').val());
    else
      $('#VC_button_inp').val($('#VC_button > img').attr('src'));
      
    //return false;
  });
  
  
  
  
  
  
  
  
});


function get_image_src(url,i, mode) {
  //var ajax_required = 0;
  if (url.search(/(\.jpg|\.gif|\.png)/i) != -1) {
    
    if (mode == 1)
      $('#theme_preview_img').replaceWith("<img id=theme_preview_img src='"+url+"'>");
    else
      $('#theme_list_wrapper').append('<img class="theme_preload_img" src='+url+'>');
    i.src = url;
  } else {
    //ajax_required = 1;
    jpg = url.replace(/\.html?/i,".jpg");
    i.src = jpg;
    if (mode == 1) {
      $('#theme_preview_img').replaceWith("<img id=theme_preview_img src='"+jpg+"'>");
      var image = $("#theme_preview_img");
      $(image).error(get_image_src_ajax(url,i, mode, image));
    }
    else {
      $('#theme_list_wrapper').append('<img class="theme_preload_img" src='+jpg+'>');
      var image = $('.theme_preload_img:last');
      $(image).error(get_image_src_ajax(url,i, mode, image));
    }
  }  

}

function get_image_src_ajax(url,i, mode, image) {
    jQuery.ajax({
    url:    "themes.cgi?ajax=get_image_src&url=" + escape(url),
    success: function(data) {
        if (data.length > 5) {
          if ((mode == 1) && ($('#theme_preview_img').attr('src') == $(image).attr('src'))) {
            $("input[value='" + url +"']").val(data);
            $('#theme_preview_img').replaceWith("<img id=theme_preview_img src='"+data+"'>");
            i.src=data; 
          } else if ((mode == 0)) {
            $("input[value='" + url +"']").val(data);
            $(image).replaceWith('<img class="theme_preload_img" src='+data+'>');
            i.src=data; 
          }
          
        }
    },
    async:   true
  });  
}



